Scriptname ClimbLadder extends ObjectReference  


Actor Property player Auto
ObjectReference Property UpMark Auto ; A marker at the top of the ladder - I use x markers
ObjectReference Property DownMark Auto ; A marker at the bottom of the ladder
ImageSpaceModifier Property LocalImageSpace Auto


Event OnActivate(ObjectReference akActionRef)
	if akActionRef == player ; This is to prevent fading if an NPC uses the ladder
		;Game.FadeOutGame(false, true, 2.0, 1.0, true)
		; fade game OUT
		
		if LocalImageSpace != None
			LocalImageSpace.FadeOutGame(true, true, 1.0, 2.0)
		else
			Game.FadeOutGame(true, true, 1.0, 2.0)
		endif
	endif
	
	if Upmark == None
		; Upmark is none when connecting worldspace to cell ladder
		Debug.Notification("Upmark = None")
		akActionRef.MoveTo(Downmark, 0, 0, 0, true)
	elseif Downmark == None
		; Downmark is none when connecting ladder to another ladder in a different cell
		akActionRef.MoveTo(Upmark, 0, 0, 0, true)
	elseif Math.Abs(akActionRef.GetPositionZ() - Upmark.GetPositionZ()) < Math.Abs(akActionRef.GetPositionZ() - Downmark.GetPositionZ())
		; We're at the top of the ladder so go down
		akActionRef.MoveTo(Downmark, 0, 0, 0, true)
	elseif Downmark != None
		; We're at the bottom of the ladder so go up
		akActionRef.MoveTo(Upmark, 0, 0, 0, true)
	endif

	if akActionRef == player ; This is to prevent fading if an NPC uses the ladder
		;Game.FadeOutGame(false, true, 2.0, 1.0)
		; fade game IN
		if LocalImageSpace != None
			LocalImageSpace.FadeOutGame(false, true, 1.0, 2.0)
		else
			Game.FadeOutGame(false, true, 1.0, 2.0)
		endif
		
	endif
	
	; Original code
	;if akActionRef.GetDistance(UpMark) > akActionRef.GetDistance(DownMark) ; Moves to marker with greatest distance.
	;	akActionRef.MoveTo(UpMark)
	;else
	;	akActionRef.MoveTo(DownMark)
	;endif
	
	
	
EndEvent